//
//  FSAApp.h
//  F-Script Anywhere
//
//  Created by Nicholas Riley on Fri Feb 01 2002.
//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
//

/*

 F-Script Anywhere is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 F-Script Anywhere is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with F-Script Anywhere; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#import <Cocoa/Cocoa.h>
#import "FSAAppList.h"

#include "SCPatchController.h"

@class FSAApp;

class FSAPatchController : public SCPatchController {
public:
    FSAPatchController(FSAApp *fsaApp);
    void PatchNotification(ProcessSerialNumber *inPSN,
                           OSType inCreator, OSType type,
                           CFStringRef name, UInt32 flags);
    void ReceiveMessage(const AppleEvent *theAE);
private:
    FSAApp *mApp;
};

@interface FSAApp : NSApplication
{
    IBOutlet NSWindow *appListWindow;
    IBOutlet FSAAppList *appList;
    FSAPatchController *patchController;
}

- (IBAction)installBundleInSelectedApp:(id)sender;

@end

@interface FSAApp (FSAPatchControllerDelegate)
- (void)controllerIsPatchingApplicationWithProcessID:(pid_t)pid;
@end